/* ------------------------------------------------------------------------------------------
 * Datei:
 *   wald.js
 * Beschreibung:
 *   Diese Datei ist das Herzstck des Spiels. Sie enthlt das eigentliche
 *   Spiel komplett in ECMAScript.
 * ------------------------------------------------------------------------------------------
 * This work is licensed under the Creative Commons Attribution 3.0 Unported License.
 * To view a copy of this license, visit http://creativecommons.org/licenses/by/3.0/ or send a letter to
 * Creative Commons, 444 Castro Street, Suite 900, Mountain View, California, 94041, USA.
 * ------------------------------------------------------------------------------------------
 * Copyright (C) 2003-2011 Kai Hildebrandt
 * ------------------------------------------------------------------------------------------
 * Liste der Funktionen:
 *
 * - BildAufbauen():	Bild aufbauen
 *
 * - EndeAnzeigen(ID):
 * 			Zeigt das Ende mit variabler Meldung an
 *
 * - HilfeAusblenden:
 * 			Hilfefenster ausblenden
 *
 * - HilfeEinblenden:
 * 			Hilfefenster einblenden
 *
 * - Init():		Initialisierung der Variablen
 *
 * - InventurAusblenden():
 * 			Die Inventur ausblenden
 *
 * - InventurEinblenden():
 * 			Die Inventur einblenden
 *
 * - MeldungAnzeigen(Meldung):
 * 			Eine Meldung anzeigen
 *
 * - MeldungAusblenden():
 * 			Die Meldung ausblenden
 *
 * - Parse():		Kommandoauswertung
 *
 * - ResetKommando():	Eingabefeld lschen, Fokus auf Eingabefeld
 */

function BildAufbauen()
{
  /* Bild und Textfenster ausblenden */
  MeldungAusblenden();

  /* Zufllige Position der Bume */
  var n = 0;

  while(n < 12) {
    document.getElementById("dBaum"+n).style.left = parseInt(Math.random() * 10) * 49 + parseInt(Math.random() * 49) +"px";
    document.getElementById("dBaum"+n).style.top  = parseInt(Math.random() * 10) + 90 +"px";
    n++;
  }

  /* Liste der sich im Raum befindenden Gegenstnde anzeigen */
  var Gegenstaende="";

  if (x == 0 && y == 0 && ri == 0) {
    document.getElementById("dRing").style.visibility = "visible";
    Gegenstaende = "Ring";
  } else {
    document.getElementById("dRing").style.visibility = "hidden";
  }


  document.fAusgabe.iGegenstaende.value = Gegenstaende;

  /* Mgliche Richtungen bestimmen */
  var Richtungen="N-O-S-W-H";

  /* Richtungen einblenden */
  document.fAusgabe.iRichtungen.value = "Mgliche Richtungen: "+Richtungen;
}

function EndeAnzeigen()
{
  document.getElementById("dEnde").style.visibility = "visible";

  //document.getElementById('aNeustart').focus();
  document.forms.fKommando.iEingabe.blur();

  /* Kommandozeile ausblenden */
  document.forms.fAusgabe.style.visibility = "hidden";
  document.forms.fKommando.style.visibility = "hidden";
  MeldungAusblenden();

  IstEnde=1;
}

function HilfeAusblenden()
{
  document.getElementById('dHilfe').style.visibility='hidden';
  ResetKommando();
}

function HilfeEinblenden()
{
  document.getElementById('dHilfe').style.visibility='visible';
  document.getElementById('iHilfeKnopf').focus();
}

function Init()
{
  x=0; y=0;				/* Position im Spiel */
  ri=0;					/* Flag, ob Ring genommen */

  /* Kein Java Script Meldung ausschalten */
  document.getElementById('dBlank').style.visibility='hidden';

  BildAufbauen();
  ResetKommando();
}

function InventurAusblenden()
{
  document.getElementById('dInv0').style.visibility='hidden';
  document.getElementById('dInv1').style.visibility='hidden';
  ResetKommando();
}

function InventurEinblenden()
{
  /* Opera lsst das ndern von versteckten Formularfeldern durch
   * Skripte nicht zu. Deshalb erst sichtbar machen, dann ndern.
   */
  if (ri == 1) {
    document.getElementById('dInv0').style.visibility='hidden';
    document.getElementById('dInv1').style.visibility='visible';
    document.forms.fInventur1.iInvKnopf1.focus();   /* Focus auf Ausblendeknopf */
  } else {
    document.getElementById('dInv0').style.visibility='visible';
    document.getElementById('dInv1').style.visibility='hidden';
    document.forms.fInventur0.iInvKnopf0.focus();   /* Focus auf Ausblendeknopf */
  }
}

function MeldungAnzeigen(Meldung)
{
  document.fTextfenster.iMeldung.style.visibility="visible";
  document.getElementById("dTextfenster").style.visibility="visible";
  document.fTextfenster.iMeldung.value=Meldung;
  // setTimeout("MeldungAusblenden()",5000);
}

function MeldungAusblenden()
{
  document.getElementById("dTextfenster").style.visibility="hidden";
  document.fTextfenster.iMeldung.style.visibility="hidden";
}

function Parse()
{
  ko = document.fKommando.iEingabe.value.toLowerCase();
  var nm = 1;   /* Flag, ob "nicht mglich" angezeigt werden soll */
  // alert("Sie gaben ein: "+ko);

  /* keine Eingabe */
  if (ko == "") { ResetKommando(); return; }

  if (ko == "inv" || ko =="inventur" || ko == "liste" || ko == "list") {
    InventurEinblenden();
    return;
  }

  if (ko.slice(0,4) == "hilf" || ko == "help") {
    HilfeEinblenden();
    return;
  }

  /* sich bewegen */
  if (ko == "n") { y--; nm=0; BildAufbauen(); }
  if (ko == "o") { x++; nm=0; BildAufbauen(); }
  if (ko == "s") { y++; nm=0; BildAufbauen(); }
  if (ko == "w") { x--; nm=0; BildAufbauen(); }
  if (ko == "h") { EndeAnzeigen(); return; }

  /* Spielstand */
  if (ko == "laden" || ko == "load" || ko == "speichern" || ko == "save") {
    MeldungAnzeigen("Die Spielstandsfunktionen sind zu diesem Zeitpunkt noch nicht verfgbar.");
    ResetKommando();
    return;
  }

  /* nehmen von Gegenstnden */
  if (ko.slice(0,4) == "nimm") {
      if (ko.slice(5,ko.length) == "ring") {
        if (x == 0 && y == 0 && ri == 0) {
	  document.getElementById("dRing").style.visibility = "hidden";
          document.fAusgabe.iGegenstaende.value = "";
	  ri = 1;
	  nm = 0;
	}
      } else {
        MeldungAnzeigen("Diesen Gegenstand gibt es hier nicht");
	ResetKommando();
	return;
      }
  }

  if (ko == "dreh ring" && ri == 1) {
    MeldungAnzeigen("Der Ring hat sich aufgelst. Alles um sie herum beginnt sich zu drehen.");
    setTimeout("Teleport()",500);
    ResetKommando();
    return;
  }

  /* nicht mglich */
  if (nm == 1) {
    MeldungAnzeigen("Nicht mglich");
    ResetKommando();
    return;
  }

  ResetKommando();
}

function ResetKommando()
{
  document.fKommando.iEingabe.value="";
  document.fKommando.iEingabe.focus();
}

function TeleportHelper(n)
{
  if (n < 30) {
    for(i=0; i<12; i++) {
      pos = parseInt(document.getElementById("dBaum"+i).style.left);
      if (Richtung[i] == 0) {
        pos = pos - 10;
	if (pos <= 0) { pos = 0; Richtung[i] = 1 - Richtung[i]; }
      } else {
        pos = pos + 10;
	if (pos >= 490) { pos = 490; Richtung[i] = 1 - Richtung[i]; }
      }
      document.getElementById("dBaum"+i).style.left = pos +"px";
    }
    setTimeout("TeleportHelper(n++)",100);
  } else {
    location.href = "schloss.html";
  }
}

function Teleport()
{
  /* 0=nach links   1=nach rechts */
  Richtung = new Array (1, 0, 1, 0,
                         0, 1, 0, 1,
			 0, 1, 0, 1,
			 1, 0, 1, 0);
  n = 0;   /* n definieren */

  /* Eingabefeld deaktivieren */
  document.forms.fKommando.iEingabe.blur();
  document.fKommando.iEingabe.disabled = "true";
  document.fKommando.iKnopf.disabled = "true";

  TeleportHelper(n);
}
